/*
 * linux/include/asm-arm/arch-dm310/ide.h
 *
 * Copyright (c) 1998 Hugo Fiennes & Nicolas Pitre
 *
 * 26-feb-2002: Add support for 2d3D SA-1110 Development board
 *              Abraham van der Merwe <abraham@2d3d.co.za>
 *
 * 18-aug-2000: Cleanup by Erik Mouw (J.A.K.Mouw@its.tudelft.nl)
 *              Get rid of the special ide_init_hwif_ports() functions
 *              and make a generalised function that can be used by all
 *              architectures.
 */

#include <linux/config.h>
#include <asm/irq.h>
#include <asm/hardware.h>
#include <asm/mach-types.h>

#include <asm/arch/msic.h>


/*
 * Set up a hw structure for a specified data port, control port and IRQ.
 * This should follow whatever the default interface uses.
 */
static __inline__ void
ide_init_hwif_ports(hw_regs_t *hw, int data_port, int ctrl_port, int *irq)
{
	/* not used */
}




/*
 * This registers the standard ports for this architecture with the IDE
 * driver.
 */
static __inline__ void
ide_init_default_hwifs(void)
{
        /* not used */
}

#define ide_get_lock(lock, hdlr, data)		msic_config_set(MSIC_CFC)
#define ide_release_lock(lock)			msic_config_release()
